import es
import path
import cfglib
import langlib
import usermsg
import popuplib
import playerlib
import gamethread
import random
from configobj import ConfigObj

info = es.AddonInfo()
info.name     = "Hide n Seek"
info.version  = "0.3"
info.url      = "None"
info.basename = "sic_hns"
info.author   = "sicman_adrian"
es.ServerVar(info.basename, info.version, info.name).makepublic()

addonDir = path.path(es.getAddonPath('hns'))
configfile = addonDir.joinpath('Propsmenu.ini')

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/hidenseek.cfg')
config.text("*****Hide n Seek*****")
sic_hns_menu_command   = config.cvar("sic_hns_menu_command",   '!props', "What player's type to bring models menu up")
sic_hns_freezetime   = config.cvar("sic_hns_freezetime",   30, "Amount of time ct's screens are faded : 1:10 seconds")
sic_hns_hider_speed   = config.cvar("ic_hns_hider_speed",   1, "How fast hider run")
config.text('')
config.text("*****Thirdperson*****")
sic_hns_3rd_advert   = config.cvar("sic_hns_3rd_advert",   1, "Adverts Thirdperson Command")
sic_hns_3rd_command   = config.cvar("sic_hns_3rd_command",   '!thirdperson', "Command to change to switch to thirdperson")
sic_hns_1rd_command   = config.cvar("sic_hns_1rd_command",   '!firstperson', "Command to change to switch to firstperson")
config.text('')
config.text("*****Firing Penalty*****")
sic_hns_fire_penalty   = config.cvar("sic_hns_fire_penalty",   1, "Penaltie's to ct for firing weapon")
sic_hns_fire_damage   = config.cvar("sic_hns_fire_damage",   1, "Amount of damage done")
config.text('')
config.text("*****Whistle*****")
sic_hns_radar_checker   = config.cvar("sic_hns_radar_checker",   1, "Checks if they enabled or havn't turned there radar off")
sic_hns_radar_warnings   = config.cvar("sic_hns_radar_warnings",   3, "Amount of warnings they get before been kicked")
config.text('')
config.text("*****Whistle*****")
sic_hns_whistle_command   = config.cvar("sic_hns_whistle_command",   '!whistle', "Command to change to whistle")
sic_hns_whistle_sound   = config.cvar("sic_hns_whistle_sound",   'hideandseek/whistle.mp3', "Sound played when whistle")
sic_hns_whistle_distance   = config.cvar("sic_hns_whistle_distance",   0.7, "Distance the sound will be emited")
config.text('')
config.text("*****Sounds*****")
sic_hns_sounds_enabled   = config.cvar("sic_hns_sounds_enabled",   1, "Enables hurt sounds etc")
sic_hns_sounds_voice   = config.cvar("sic_hns_sounds_voice",   'male', "Male or Female voices")
sic_hns_sounds_hurt   = config.cvar("sic_hns_sounds_hurt",   1, "Play's hurt sounds when Hiders have been hurt")
config.text('')
config.text("*****Extra's*****")
sic_hns_noblock   = config.cvar("sic_hns_noblock",   1, "Enables noblock")

config.write()

player_dict = {}
props_dict = {}

male_list = ['sound/hnsan/canman.wav','sound/hnsan/hiderman.wav','sound/hnsan/seekerdiedman.wav','sound/hnsan/seekerswinman.wav','sound/hnsan/swappedman.wav']
female_list = ['sound/hnsan/canwoman.wav','sound/hnsan/hiderwoman.wav','sound/hnsan/seekerdiedwoman.wav','sound/hnsan/seekerswinwoman.wav','sound/hnsan/swappedwoman.wav']
text = None

def load():
    global text
    config.execute()
    if not es.exists('saycommand', sic_hns_3rd_command):
        es.regsaycmd(sic_hns_3rd_command, 'hns/third', "ThirdPerson")
    if not es.exists('saycommand', sic_hns_1rd_command):
        es.regsaycmd(sic_hns_1rd_command, 'hns/first', "Firstperson")
    if not es.exists('saycommand', sic_hns_whistle_command):
        es.regsaycmd(sic_hns_whistle_command, 'hns/whistle', "whistle")
    if not es.exists('saycommand', sic_hns_menu_command):
        es.regsaycmd(sic_hns_menu_command, 'hns/sendpopup', "Model menu")
    downloads()
    text = langlib.Strings(es.getAddonPath("hns") + "/strings.ini")
    es.msg('#multi', text("load"))
    if sic_hns_sounds_hurt == 1:
        es.doblock('corelib/noisy_on')
    es.server.queuecmd("es_load extendedevents")
    es.server.queuecmd("extendedevents_load player_duck")

def unload():
    es.msg('#multi', text("unload"))
    popuplib.delete('sic_propsmenu')
    es.doblock('corelib/noisy_off')

def downloads():
    if sic_hns_sounds_voice == 'male':
        for sound in male_list:
            es.stringtable('downloadables', sound)
    else:
        for sound in female_list:
            es.stringtable('downloadables', sound)
    es.stringtable('downloadables', 'sound/hideandseek/terminated.wav')
    es.stringtable('downloadables', 'sound/hideandseek/goodbye.wav')
    es.stringtable('downloadables', 'sound/hideandseek/notnice.wav')
    es.stringtable('downloadables', str(sic_hns_whistle_sound))
    


def es_map_start(ev):
    downloads()
    c = ConfigObj(configfile)
    props_dict = c[str(es.ServerVar('eventscripts_currentmap'))]
    sic_propsmenu = popuplib.easymenu('sic_propsmenu', '_popup_choice', propsmenu_menuselect)
    sic_propsmenu.settitle('Model\'s Menu')
    for x in props_dict: sic_propsmenu.addoption(props_dict[x], x)

def third():
    userid = es.getcmduserid()
    es.setplayerprop(userid, 'CBasePlayer.m_hObserverTarget', 0)
    es.setplayerprop(userid, 'CBasePlayer.m_iObserverMode', 1)
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDrawViewmodel', 0)
    es.setplayerprop(userid, 'CBasePlayer.m_iFOV', 100)

def first():
    userid = es.getcmduserid()
    es.setplayerprop(userid, 'CBasePlayer.m_hObserverTarget', 0)
    es.setplayerprop(userid, 'CBasePlayer.m_iObserverMode', 0)
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDrawViewmodel', 1)
    es.setplayerprop(userid, 'CBasePlayer.m_iFOV', 90)

def whistle():
    userid = str(es.getcmduserid())
    if player_dict[userid]['whistle'] == 0:
        es.emitsound('player', userid, str(sic_hns_whistle_sound),1.0 ,int(sic_hns_whistle_distance))
        player_dict[userid]['whistle'] = 1
        gamethread.delayedname(sic_hns_freezetime, 'reset %s'%userid, reset, userid)
        
def reset(userid):
    player_dict[userid]['whistle'] = 0


def player_activate(ev):
    global player_dict
    userid = ev['userid']
    if userid not in player_dict:
        player_dict[userid] = {'model':0,'whistle':0,'kick':0}
    if sic_hns_radar_checker == 1:
        es.usermsg('create', 'sic_hns', 'VGUIMenu')
        es.usermsg('write', 'string', 'sic_hns', 'info')
        es.usermsg('write', 'byte', 'sic_hns', 1)
        es.usermsg('write', 'byte', 'sic_hns', 4)
        es.usermsg('write', 'string', 'sic_hns', 'title')
        es.usermsg('write', 'string', 'sic_hns', 'SIC-HnS')
        es.usermsg('write', 'string', 'sic_hns', 'msg')
        es.usermsg('write', 'string', 'sic_hns', 'This server Forces cl_radaralpha to 0 to disable radar. If changed you will be kicked')
        es.usermsg('write', 'string', 'sic_hns', 'cmd')
        es.usermsg('write', 'string', 'sic_hns', 'cl_radaralpha 0')
        es.usermsg('send', 'sic_hns', userid)
        es.usermsg('delete', 'sic_hns')

def player_team(ev):
    checker(ev['userid'])


def player_spawn(ev):
    userid = ev['userid']
    player = playerlib.getPlayer(userid)
    es.queryclientvar(userid, 'cl_radaralpha')
    if sic_hns_noblock == 1:
        es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
    if ev['es_userteam'] == '2':
        popuplib.send('sic_propsmenu', userid)
        if player_dict[userid]['model'] != 0:
            player.set('model', player_dict[userid]['model'])
            es.server.queuecmd('es_xfire %s !self addoutput "rendermode 1"' % userid)
        es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", sic_hns_hider_speed)
        es.tell(userid, '#multi', text("hidego") % sic_hns_freezetime)
        if sic_hns_3rd_advert == 1:
            es.tell(userid, '#multi', text("thirdperson") % (sic_hns_3rd_command, sic_hns_1rd_command))

def item_pickup(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2':
        es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
        es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)


def undo(userid):
    es.setplayerprop(userid, 'CCSPlayer.m_iProgressBarDuration', 0)
    es.setplayerprop(userid, "CBaseEntity.movetype", 2)

def sendpopup():
    userid = es.getcmduserid()
    if es.getplayerteam(userid) == '2':
        if popuplib.active(userid)['name'] != '0':
            popuplib.close(popuplib.active(userid)['name'], userid)
        popuplib.send('sic_propsmenu', userid)

def checker(userid):
    gamethread.cancelDelayed('checker ' + userid)
    gamethread.delayedname(150, 'checker %s'% userid, checker, userid)
    es.queryclientvar(userid, 'cl_radaralpha')

def es_player_variable(ev):
    userid = ev['userid']
    if ev['status'] == 'success':
        if ev['variable'] == 'cl_radaralpha':
            if int(ev['value']) != 0:
                es.changeteam(ev['userid'], 1)
                es.tell(userid, '#multi',text("warning"))
                player_dict[userid]['kick'] += 1
                if player_dict[userid]['kick'] >= sic_hns_radar_warnings:
                    es.emitsound('player', userid, 'hideandseek/terminated.wav', 1.0, 0)
                    es.playsound(userid, 'hideandseek/goodbye.wav',1.0)
                    es.server.queuecmd('kickid %s %s' % (userid, text("kick")))

def player_death(ev):
    userid = ev['userid']
    es.queryclientvar(userid, 'cl_radaralpha')
    if ev['es_userteam'] == '2':
        if sic_hns_sounds_enabled == 1:
            if sic_hns_sounds_voice == 'male':
                es.emitsound('player', userid, 'hnsan/hiderman.wav', 1.0, 0.2)
            else:
                es.emitsound('player', userid, 'hnsan/hiderwoman.wav', 1.0, 0.2)
    else:
        if sic_hns_sounds_enabled == 1:
            if sic_hns_sounds_voice == 'female':
                es.emitsound('player', userid, 'hnsan/seekerdiedman.wav', 1.0, 0.2)
            else:
                es.emitsound('player', userid, 'hnsan/seekerdiedwoman.wav', 1.0, 0.2)

pain_list = ['vo/npc/male01/pain02.wav','vo/npc/male01/pain03.wav','vo/npc/male01/pain04.wav','vo/npc/male01/pain05.wav','vo/npc/male01/pain06.wav','vo/npc/male01/pain07.wav','vo/npc/male01/pain08.wav','vo/npc/male01/pain09.wav']
def player_hurt(ev):
    userid = ev['userid']
    attacker = ev['attacker']
    if ev['es_userteam'] == '2':
        if sic_hns_sounds_hurt == 1:
            es.playsound(userid, random.choice(pain_list),1.0)

def weapon_fire(ev):
    if sic_hns_fire_penalty == 1:
        hp = es.getplayerprop(ev['userid'], 'CBasePlayer.m_iHealth')
        es.setplayerprop(ev['userid'], 'CBasePlayer.m_iHealth', hp - sic_hns_fire_damage)

def propsmenu_menuselect (userid, choice, popupid):
    player = playerlib.getPlayer(str(userid))
    player_dict[str(userid)]['model'] = choice
    player_dict[str(userid)]['menu'] = 1
    player.set('model', player_dict[str(userid)]['model'])
    es.server.queuecmd('es_xfire %s !self addoutput "rendermode 1"' % userid)

def player_disconnect(ev):
    del player_dict[ev['userid']]
    for delay in ['undo ','reset ','checker ']:
        gamethread.cancelDelayed(delay + ev['userid'])

def round_start(ev):
    time = sic_hns_freezetime * 540
    usermsg.fade('#ct', 0, time , 0, 0, 0, 0)
    for userid in es.getUseridList():
        es.setplayerprop(userid, 'CCSPlayer.m_iProgressBarDuration', int(sic_hns_freezetime))
        es.setplayerprop(userid, "CBaseEntity.movetype", 0)
        gamethread.delayedname(sic_hns_freezetime, 'undo %s'%userid, undo, userid)

def player_flag(ev):
    flag = es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2
    if flag == '1':
        es.setplayerprop(ev['userid'], 'CBasePlayer.localdata.m_Local.m_bDucked', 0)
